輿情監察及提及
建立公開監察串流
明確設定字面查詢、來源篩選、採集頻率及 authorization_expires_at,建立有期限的 HN 聆聽串流。需要目前 agent:research 及工作空間編輯權;建立設定不會自行啟用停用中的採集服務。
POST /listening-api/streams/createContract 核對日期: · sha256:ab393e91e9b7f18a
概覽
明確設定字面查詢、來源篩選、採集頻率及 authorization_expires_at,建立有期限的 HN 聆聽串流。需要目前 agent:research 及工作空間編輯權;建立設定不會自行啟用停用中的採集服務。
HTTP 成功只表示本次操作的回應。背景工作須保留回傳 ID,並讀取同一操作,直至達到文件指定的終態。接受請求、排程成功或客戶端逾時,均不代表已發佈。
驗證及權限
憑證不能擴大持有人的權限。實際操作仍會檢查工作空間成員資格、資源擁有權、已選工作空間及能力授權。Tool profile 只會改變可見工具,不會授予權限。
請求欄位
必填表示在所屬物件及所選分支內必須提供;子欄位必填不代表可選的父物件亦變成必填。以下欄位名稱及規則直接來自 contract。
| 欄位/分支 | 類型/必填 | 限制 |
|---|---|---|
$ | object父物件內必填 |
|
workspace_id | string父物件內必填 |
|
mutation_id | string父物件內必填 |
|
content | object父物件內必填 |
|
content.name | string父物件內必填 |
|
content.query | string父物件內必填 |
|
content.source_overrides | object可選/陣列項目 |
|
content.source_overrides.hacker_news | string可選/陣列項目 |
|
content.include_terms | array可選/陣列項目 |
|
content.include_terms[] | string可選/陣列項目 |
|
content.exclude_terms | array可選/陣列項目 |
|
content.exclude_terms[] | string可選/陣列項目 |
|
content.item_types | array可選/陣列項目 |
|
content.item_types[] | string可選/陣列項目 |
|
content.cadence_minutes | integer可選/陣列項目 |
|
content.lookback_days | integer可選/陣列項目 |
|
authorization_expires_at | string父物件內必填 |
|
完整 JSON Schema
{
"$schema": "https://json-schema.org/draft/2020-12/schema",
"type": "object",
"properties": {
"workspace_id": {
"type": "string",
"format": "uuid",
"pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
},
"mutation_id": {
"type": "string",
"format": "uuid",
"pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
},
"content": {
"type": "object",
"properties": {
"name": {
"type": "string",
"minLength": 1,
"maxLength": 120
},
"query": {
"type": "string",
"minLength": 1,
"maxLength": 200
},
"source_overrides": {
"default": {},
"type": "object",
"properties": {
"hacker_news": {
"type": "string",
"minLength": 1,
"maxLength": 200
}
},
"additionalProperties": false
},
"include_terms": {
"default": [],
"maxItems": 20,
"type": "array",
"items": {
"type": "string",
"minLength": 1,
"maxLength": 100
}
},
"exclude_terms": {
"default": [],
"maxItems": 20,
"type": "array",
"items": {
"type": "string",
"minLength": 1,
"maxLength": 100
}
},
"item_types": {
"default": [
"story",
"comment"
],
"minItems": 1,
"maxItems": 2,
"type": "array",
"items": {
"type": "string",
"enum": [
"story",
"comment"
]
}
},
"cadence_minutes": {
"default": 60,
"type": "integer",
"minimum": 30,
"maximum": 1440
},
"lookback_days": {
"default": 7,
"type": "integer",
"minimum": 1,
"maximum": 7
}
},
"required": [
"name",
"query"
],
"additionalProperties": false
},
"authorization_expires_at": {
"type": "string",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
"format": "date-time"
}
},
"required": [
"workspace_id",
"mutation_id",
"content",
"authorization_expires_at"
],
"additionalProperties": false
}回應及完成條件
成功 HTTP 狀態碼: 200. 完成依據: committed Listening resource version or cancellation fence; no social platform writes.
HTTP 成功只表示本次操作的回應。背景工作須保留回傳 ID,並讀取同一操作,直至達到文件指定的終態。接受請求、排程成功或客戶端逾時,均不代表已發佈。
必填表示在所屬物件及所選分支內必須提供;子欄位必填不代表可選的父物件亦變成必填。以下欄位名稱及規則直接來自 contract。
| 欄位/分支 | 類型/必填 | 限制 |
|---|---|---|
$ | object父物件內必填 | — |
stream | object父物件內必填 | — |
stream.id | string父物件內必填 |
|
stream.workspace_id | string父物件內必填 |
|
stream.revision | integer父物件內必填 |
|
stream.query_revision | integer父物件內必填 |
|
stream.generation | integer父物件內必填 |
|
stream.source | string父物件內必填 |
|
stream.content | object父物件內必填 | — |
stream.content.name | string父物件內必填 |
|
stream.content.query | string父物件內必填 |
|
stream.content.source_overrides | object父物件內必填 |
|
stream.content.source_overrides.hacker_news | string可選/陣列項目 |
|
stream.content.include_terms | array父物件內必填 |
|
stream.content.include_terms[] | string可選/陣列項目 |
|
stream.content.exclude_terms | array父物件內必填 |
|
stream.content.exclude_terms[] | string可選/陣列項目 |
|
stream.content.item_types | array父物件內必填 |
|
stream.content.item_types[] | string可選/陣列項目 |
|
stream.content.cadence_minutes | integer父物件內必填 |
|
stream.content.lookback_days | integer父物件內必填 |
|
stream.state | string父物件內必填 |
|
stream.authorization_expires_at | string | null父物件內必填 | — |
stream.authorization_expires_atanyOf 1 | string父物件內必填 |
|
stream.authorization_expires_atanyOf 2 | null父物件內必填 | — |
stream.last_attempt_at | string | null父物件內必填 | — |
stream.last_attempt_atanyOf 1 | string父物件內必填 |
|
stream.last_attempt_atanyOf 2 | null父物件內必填 | — |
stream.last_success_at | string | null父物件內必填 | — |
stream.last_success_atanyOf 1 | string父物件內必填 |
|
stream.last_success_atanyOf 2 | null父物件內必填 | — |
stream.next_due_at | string | null父物件內必填 | — |
stream.next_due_atanyOf 1 | string父物件內必填 |
|
stream.next_due_atanyOf 2 | null父物件內必填 | — |
stream.created_at | string父物件內必填 |
|
stream.updated_at | string父物件內必填 |
|
完整 JSON Schema
{
"$schema": "https://json-schema.org/draft/2020-12/schema",
"type": "object",
"properties": {
"stream": {
"type": "object",
"properties": {
"id": {
"type": "string",
"format": "uuid",
"pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
},
"workspace_id": {
"type": "string",
"format": "uuid",
"pattern": "^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$"
},
"revision": {
"type": "integer",
"exclusiveMinimum": 0,
"maximum": 9007199254740991
},
"query_revision": {
"type": "integer",
"exclusiveMinimum": 0,
"maximum": 9007199254740991
},
"generation": {
"type": "integer",
"exclusiveMinimum": 0,
"maximum": 9007199254740991
},
"source": {
"type": "string",
"const": "hacker_news"
},
"content": {
"type": "object",
"properties": {
"name": {
"type": "string",
"minLength": 1,
"maxLength": 120
},
"query": {
"type": "string",
"minLength": 1,
"maxLength": 200
},
"source_overrides": {
"default": {},
"type": "object",
"properties": {
"hacker_news": {
"type": "string",
"minLength": 1,
"maxLength": 200
}
}
},
"include_terms": {
"default": [],
"maxItems": 20,
"type": "array",
"items": {
"type": "string",
"minLength": 1,
"maxLength": 100
}
},
"exclude_terms": {
"default": [],
"maxItems": 20,
"type": "array",
"items": {
"type": "string",
"minLength": 1,
"maxLength": 100
}
},
"item_types": {
"default": [
"story",
"comment"
],
"minItems": 1,
"maxItems": 2,
"type": "array",
"items": {
"type": "string",
"enum": [
"story",
"comment"
]
}
},
"cadence_minutes": {
"default": 60,
"type": "integer",
"minimum": 30,
"maximum": 1440
},
"lookback_days": {
"default": 7,
"type": "integer",
"minimum": 1,
"maximum": 7
}
},
"required": [
"name",
"query",
"source_overrides",
"include_terms",
"exclude_terms",
"item_types",
"cadence_minutes",
"lookback_days"
]
},
"state": {
"type": "string",
"enum": [
"active",
"paused",
"needs_reauthorization",
"deleted"
]
},
"authorization_expires_at": {
"anyOf": [
{
"type": "string",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
"format": "date-time"
},
{
"type": "null"
}
]
},
"last_attempt_at": {
"anyOf": [
{
"type": "string",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
"format": "date-time"
},
{
"type": "null"
}
]
},
"last_success_at": {
"anyOf": [
{
"type": "string",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
"format": "date-time"
},
{
"type": "null"
}
]
},
"next_due_at": {
"anyOf": [
{
"type": "string",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
"format": "date-time"
},
{
"type": "null"
}
]
},
"created_at": {
"type": "string",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
"format": "date-time"
},
"updated_at": {
"type": "string",
"pattern": "^(?:(?:\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\\d|30)|(?:02)-(?:0[1-9]|1\\d|2[0-8])))T(?:(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(?:\\.\\d+)?)?(?:Z|([+-](?:[01]\\d|2[0-3]):[0-5]\\d)))$",
"format": "date-time"
}
},
"required": [
"id",
"workspace_id",
"revision",
"query_revision",
"generation",
"source",
"content",
"state",
"authorization_expires_at",
"last_attempt_at",
"last_success_at",
"next_due_at",
"created_at",
"updated_at"
]
}
},
"required": [
"stream"
]
}錯誤及安全重試
請檢查 HTTP 狀態及實際回應格式。400 驗證錯誤可能回傳 ZodError;handler 錯誤可能採用 error/message/code envelope。請保留可用的 request_id 或 x-request-id,避免記錄憑證。遇到 401/403 時,須先修正存取問題;429 須遵守 Retry-After。寫入結果未明或回傳 5xx 時,請先讀取原有結果,再決定是否重試。只有操作支援時才可重用 idempotency key;並無通用重試或 exactly-once 保證。
問題排解指南範例
以下虛構值已按 contract 驗證,並非真實帳戶 ID、憑證或發佈紀錄。請以已授權範圍回傳的 ID、已準備完成的素材及已審核排程取代,並在寫入前核對平台資格。此頁不會呼叫 API。
在伺服器環境設定 SOSOAPI_ACCESS_TOKEN,使用此操作接受的憑證。請勿將憑證放入瀏覽器程式。一般 AI Agent 建議透過 sosoapi auth login 使用瀏覽器 OAuth,由 CLI 管理憑證更新。
request.json
{
"workspace_id": "11111111-1111-4111-8111-111111111111",
"mutation_id": "11111111-1111-4111-8111-111111111111",
"content": {
"name": "example",
"query": "example"
},
"authorization_expires_at": "2099-01-15T09:00:00Z"
}cURL
curl --request POST \
"https://gqeshlawtcexsapabaui.supabase.co/functions/v1/listening-api/streams/create" \
-H "Authorization: Bearer $SOSOAPI_ACCESS_TOKEN" \
-H "Content-Type: application/json" \
--data-binary @request.jsonJavaScript
// Server-side JavaScript. Do not print tokens or credential-bearing responses.
const token = process.env.SOSOAPI_ACCESS_TOKEN;
if (!token) throw new Error("Set an accepted credential for this operation");
const response = await fetch("https://gqeshlawtcexsapabaui.supabase.co/functions/v1/listening-api/streams/create", {
method: "POST",
headers: { "Content-Type": "application/json", Authorization: "Bearer " + token },
body: JSON.stringify({
"workspace_id": "11111111-1111-4111-8111-111111111111",
"mutation_id": "11111111-1111-4111-8111-111111111111",
"content": {
"name": "example",
"query": "example"
},
"authorization_expires_at": "2099-01-15T09:00:00Z"
})
});
const result = await response.json();
// Check response.ok, the operation-specific body and completion state before continuing.CLI
npx sosoapi api post /listening-api/streams/create < request.json虛構回應範例
{
"stream": {
"id": "11111111-1111-4111-8111-111111111111",
"workspace_id": "11111111-1111-4111-8111-111111111111",
"revision": 1,
"query_revision": 1,
"generation": 1,
"source": "hacker_news",
"content": {
"name": "example",
"query": "example",
"source_overrides": {},
"include_terms": [],
"exclude_terms": [],
"item_types": [
"story",
"comment"
],
"cadence_minutes": 60,
"lookback_days": 7
},
"state": "active",
"authorization_expires_at": null,
"last_attempt_at": null,
"last_success_at": null,
"next_due_at": null,
"created_at": "2099-01-15T09:00:00Z",
"updated_at": "2099-01-15T09:00:00Z"
}
}